summaryrefslogtreecommitdiff
path: root/source4/script
diff options
context:
space:
mode:
authorStefan Metzmacher <metze@samba.org>2007-04-17 13:48:12 +0000
committerGerald (Jerry) Carter <jerry@samba.org>2007-10-10 14:51:00 -0500
commit8934c3f68e0ba949edd38673f10b9943059e4938 (patch)
treefeaf571dd10bfd0e11c497ef45149b70932d4a9c /source4/script
parent57dd182915c3e81291a3aa48bd6c6795fd00a96f (diff)
downloadsamba-8934c3f68e0ba949edd38673f10b9943059e4938.tar.gz
samba-8934c3f68e0ba949edd38673f10b9943059e4938.tar.bz2
samba-8934c3f68e0ba949edd38673f10b9943059e4938.zip
r22307: when no lex or yacc is found:
- just touch $DEST if it's already there and newer than $SRC - touch $DEST if it's already there but older than $SRC and print warnings to stderr - otherwise return an error when lex or yacc is found: - just touch $DEST if it's already there and newer than $SRC - otherwise regenerate $DEST from $SRC using lex or yacc I don't like that every 'make' tries to regenerate because the timestamp of $DEST is never updated... metze (This used to be commit 10ed5c39692ff4a6b61ec9c6d046b2ee2202fc02)
Diffstat (limited to 'source4/script')
-rwxr-xr-xsource4/script/lex_compile.sh16
-rwxr-xr-xsource4/script/yacc_compile.sh18
2 files changed, 29 insertions, 5 deletions
diff --git a/source4/script/lex_compile.sh b/source4/script/lex_compile.sh
index 064bf89bea..2f9498e5ac 100755
--- a/source4/script/lex_compile.sh
+++ b/source4/script/lex_compile.sh
@@ -8,11 +8,23 @@ dir=`dirname $SRC`
file=`basename $SRC`
base=`basename $SRC .l`
if [ -z "$LEX" ]; then
- echo "lex not found - not regenerating $DEST"
- exit;
+ # if $DEST is more recent than $SRC, we can just touch
+ # otherwise we touch but print out warnings
+ if [ -r $DEST ]; then
+ if [ x`find $SRC -newer $DEST -print` = x$SRC ]; then
+ echo "warning: lex not found - cannot generate $SRC => $DEST" >&2
+ echo "warning: lex not found - only updating the timestamp of $DEST" >&2
+ fi
+ touch $DEST;
+ exit;
+ fi
+ echo "error: lex not found - cannot generate $SRC => $DEST" >&2
+ exit 1;
fi
+# if $DEST is more recent than $SRC, we can just touch
if [ -r $DEST ]; then
if [ x`find $SRC -newer $DEST -print` != x$SRC ]; then
+ touch $DEST;
exit;
fi
fi
diff --git a/source4/script/yacc_compile.sh b/source4/script/yacc_compile.sh
index 87d9807fc6..c82ef6d686 100755
--- a/source4/script/yacc_compile.sh
+++ b/source4/script/yacc_compile.sh
@@ -8,18 +8,30 @@ dir=`dirname $SRC`
file=`basename $SRC`
base=`basename $SRC .y`
if [ -z "$YACC" ]; then
- echo "yacc not found"
- exit;
+ # if $DEST is more recent than $SRC, we can just touch
+ # otherwise we touch but print out warnings
+ if [ -r $DEST ]; then
+ if [ x`find $SRC -newer $DEST -print` = x$SRC ]; then
+ echo "warning: yacc not found - cannot generate $SRC => $DEST" >&2
+ echo "warning: yacc not found - only updating the timestamp of $DEST" >&2
+ fi
+ touch $DEST;
+ exit;
+ fi
+ echo "error: yacc not found - cannot generate $SRC => $DEST" >&2
+ exit 1;
fi
+# if $DEST is more recent than $SRC, we can just touch
if [ -r $DEST ]; then
if [ x`find $SRC -newer $DEST -print` != x$SRC ]; then
+ touch $DEST;
exit;
fi
fi
TOP=`pwd`
if cd $dir && $YACC -d $file; then
if [ -r y.tab.h -a -r y.tab.c ];then
- echo "move files"
+ #echo "info: move files"
sed -e "/^#/!b" -e "/^#/ s|y\.tab\.h|$SRC|" -e "/^#/ s|\"$base.y|\"$SRC|" y.tab.h > $base.h
sed -e "/^#/ s|y\.tab\.c|$SRC|" -e "/^#/ s|\"$base.y|\"$SRC|" y.tab.c > $base.c
rm -f y.tab.c y.tab.h